;*****************************************************************************
;* AVR Music v1.0                                                            *
;*      .               *
;*  . Email:qwerty@nara.ru                                    *
;*  : 21  2002 .                                      *
;*****************************************************************************
; :
; * : ATtiny12 (22).
; *   - 1  ( RC-).
;*****************************************************************************

.include "tn12def.inc"

;********************  **********************
.def  fCOUNTER    =r16   ;     .
.def  fCOUNTER2   =r17   ; 2.
.def  fBEEP_CNT   =r18   ;  .
.def  fTEMP       =r19   ;      .

.equ PORTB_IO_MAP =0b00011111 ;   (0 - , 1 - ).
.equ  BEEPER    =3     ; .



.cseg                                   ; CODE
.org 0
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;                                 
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
Start:
        clr     fTEMP
        out     PORTB,fTEMP

        ldi     fTEMP,PORTB_IO_MAP
        out     DDRB,fTEMP

        ldi     fTEMP,33     ;    .
        out     OSCCAL,fTEMP
;
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;                                    
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

MainLoop:
        rcall   Ulitka
        rjmp    MainLoop
;-----------------------------------------------------------------------------
delay:
        mov     fCOUNTER,fTEMP
d_loop:
        dec     fCOUNTER
        brne    d_loop
        ret
;--------------------------------------------------------------------------
Big_delay:
        mov     fCOUNTER2,fTEMP
        clr     fCOUNTER
BD_loop:
        dec     fCOUNTER
        brne    BD_loop
        dec     fCOUNTER2
        brne    BD_loop
        ret
;-----------------------------------------------------------------------------
;  .
;-----------------------------------------------------------------------------
Beep_C: ; : 1.911079 ms. 1911 cycles.
        ldi     fBEEP_CNT,52
BC_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,2
        rcall   Big_delay
        ldi     fTEMP,117
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,2
        rcall   Big_delay
        ldi     fTEMP,116
        rcall   delay
        dec     fBEEP_CNT
        brne    BC_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_C_diez: ; #: 1.803824 ms. 1805 cycles.
        ldi     fBEEP_CNT,55
BCd_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,2
        rcall   Big_delay
        ldi     fTEMP,82
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,2
        rcall   Big_delay
        ldi     fTEMP,81
        rcall   delay
        dec     fBEEP_CNT
        brne    BCd_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_D: ; : 1.702588 ms. 1703 cycles.
        ldi     fBEEP_CNT,59
BD_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,2
        rcall   Big_delay
        ldi     fTEMP,48
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,2
        rcall   Big_delay
        ldi     fTEMP,47
        rcall   delay
        dec     fBEEP_CNT
        brne    BD_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_D_diez: ; #: 1.6070334 ms. 1607 cycles.
        ldi     fBEEP_CNT,62
BDd_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,2
        rcall   Big_delay
        ldi     fTEMP,16
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,2
        rcall   Big_delay
        ldi     fTEMP,15
        rcall   delay
        dec     fBEEP_CNT
        brne    BDd_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_E: ; : 1.516842 ms. 1517 cycles.
        ldi     fBEEP_CNT,66
BE_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,244
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,243
        rcall   delay
        dec     fBEEP_CNT
        brne    BE_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_F: ; : 1.431712 ms. 1432 cycles.
        ldi     fBEEP_CNT,70
BF_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,215
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,214
        rcall   delay
        dec     fBEEP_CNT
        brne    BF_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_F_diez: ; #: 1.351360 ms. 1351 cycles.
        ldi     fBEEP_CNT,74
BFd_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,188
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,187
        rcall   delay
        dec     fBEEP_CNT
        brne    BFd_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_G: ; : 1.275518 ms. 1275 cycles.
        ldi     fBEEP_CNT,78
BG_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,163
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,162
        rcall   delay
        dec     fBEEP_CNT
        brne    BG_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_G_diez: ; #: 1.203932 ms. 1204 cycles.
        ldi     fBEEP_CNT,83
BGd_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,139
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,138
        rcall   delay
        dec     fBEEP_CNT
        brne    BGd_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_A: ; : 1.136363 ms. 1136 cycles.
        ldi     fBEEP_CNT,88
BA_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,117
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,116
        rcall   delay
        dec     fBEEP_CNT
        brne    BA_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_A_diez: ; #: 1.072587 ms. 1073 cycles.
        ldi     fBEEP_CNT,93
BAd_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,96
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,95
        rcall   delay
        dec     fBEEP_CNT
        brne    BAd_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_B: ; : 1.012391 ms. 1012 cycles.
        ldi     fBEEP_CNT,99
BB_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,75
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,74
        rcall   delay
        dec     fBEEP_CNT
        brne    BB_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_C2: ;   : 0.955572 ms. 956 cycles.
        ldi     fBEEP_CNT,105
BC2_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,57
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,56
        rcall   delay
        dec     fBEEP_CNT
        brne    BC2_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_C2_diez: ; #  : 0.901943 ms. 902 cycles.
        ldi     fBEEP_CNT,111
BC2d_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,39
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,38
        rcall   delay
        dec     fBEEP_CNT
        brne    BC2d_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_D2: ;   : 0.85132 ms. 851 cycles.
        ldi     fBEEP_CNT,118
BD2_BeepLoop:
        sbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,22
        rcall   delay
        cbi     PORTB,BEEPER
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,21
        rcall   delay
        dec     fBEEP_CNT
        brne    BD2_BeepLoop
        ret
;-----------------------------------------------------------------------------
Beep_Separator:
        ldi     fTEMP,10
        rcall   Big_delay
        ret
;-----------------------------------------------------------------------------
Beep_Pause:
        ldi     fBEEP_CNT,118
BP_BeepLoop:
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,22
        rcall   delay
        ldi     fTEMP,0
        rcall   delay
        ldi     fTEMP,21
        rcall   delay
        dec     fBEEP_CNT
        brne    BP_BeepLoop
        ret
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
Ulitka:
        rcall   Beep_G
        rcall   Beep_E
        rcall   Beep_A
        rcall   Beep_A
        rcall   Beep_G
        rcall   Beep_G
        rcall   Beep_D
        rcall   Beep_F
        rcall   Beep_E
        rcall   Beep_D
        rcall   Beep_C
        rcall   Beep_C
        rcall   Beep_C
        rcall   Beep_C
        rcall   Beep_Pause
        rcall   Beep_Pause
        rcall   Beep_E
        rcall   Beep_G
        rcall   Beep_A
        rcall   Beep_Separator
        rcall   Beep_A
        rcall   Beep_Separator
        rcall   Beep_A
        rcall   Beep_Separator
        rcall   Beep_B
        rcall   Beep_D2
        rcall   Beep_C2
        rcall   Beep_B
        rcall   Beep_A
        rcall   Beep_C2
        rcall   Beep_C2
        rcall   Beep_G
        rcall   Beep_G
        rcall   Beep_Pause
        rcall   Beep_Pause
        rcall   Beep_A
        rcall   Beep_B
        rcall   Beep_C2
        rcall   Beep_C2
        rcall   Beep_C2
        rcall   Beep_B
        rcall   Beep_A
        rcall   Beep_E
        rcall   Beep_G
        rcall   Beep_F
        rcall   Beep_A
        rcall   Beep_A
        rcall   Beep_A
        rcall   Beep_A
        rcall   Beep_Pause
        rcall   Beep_Pause
        rcall   Beep_B
        rcall   Beep_A
        rcall   Beep_C2
        rcall   Beep_G
        rcall   Beep_B
        rcall   Beep_A
        rcall   Beep_Separator
        rcall   Beep_A
        rcall   Beep_G
        rcall   Beep_D
        rcall   Beep_E
        rcall   Beep_D
        rcall   Beep_D
        rcall   Beep_C
        rcall   Beep_C
        rcall   Beep_Pause
        rcall   Beep_Pause
        rcall   Beep_Separator
        rcall   Beep_C
        rcall   Beep_D_diez
        rcall   Beep_G
        rcall   Beep_Separator
        rcall   Beep_G
        rcall   Beep_Separator
        rcall   Beep_G
        rcall   Beep_Separator
        rcall   Beep_G
        rcall   Beep_Separator
        rcall   Beep_G
        rcall   Beep_Pause
        rcall   Beep_C2
        rcall   Beep_C
        rcall   Beep_D_diez
        rcall   Beep_D
        rcall   Beep_Separator
        rcall   Beep_D
        rcall   Beep_Separator
        rcall   Beep_D
        rcall   Beep_Separator
        rcall   Beep_D
        rcall   Beep_Pause
        rcall   Beep_D
        rcall   Beep_D_diez
        rcall   Beep_G
        rcall   Beep_F
        rcall   Beep_G
        rcall   Beep_G_diez
        rcall   Beep_G
        rcall   Beep_F
        rcall   Beep_G
        rcall   Beep_G_diez
        rcall   Beep_C2
        rcall   Beep_C2
        rcall   Beep_A_diez
        rcall   Beep_A_diez
        rcall   Beep_A_diez
        rcall   Beep_A_diez
        rcall   Beep_C2
        rcall   Beep_G
        rcall   Beep_A_diez
        rcall   Beep_G_diez
        rcall   Beep_Separator
        rcall   Beep_G_diez
        rcall   Beep_Separator
        rcall   Beep_G_diez
        rcall   Beep_Separator
        rcall   Beep_G_diez
        rcall   Beep_Pause
        rcall   Beep_C2
        rcall   Beep_F
        rcall   Beep_G_diez
        rcall   Beep_G
        rcall   Beep_Separator
        rcall   Beep_G
        rcall   Beep_Separator
        rcall   Beep_G
        rcall   Beep_Separator
        rcall   Beep_G
        rcall   Beep_Pause
        rcall   Beep_C2
        rcall   Beep_D_diez
        rcall   Beep_D
        rcall   Beep_D_diez
        rcall   Beep_F
        rcall   Beep_G_diez
        rcall   Beep_G
        rcall   Beep_F
        rcall   Beep_D_diez
        rcall   Beep_F
        rcall   Beep_G
        rcall   Beep_G
        rcall   Beep_C
        rcall   Beep_C
        rcall   Beep_Pause
        rcall   Beep_Pause
        ret
;-----------------------------------------------------------------------------
